
import os
import re
from mock import patch, MagicMock
from django.test import TestCase
from psqa.util.cobertura import (get_line_rate_from_cobertura_xml,
                                 get_branch_rate_from_cobertura_xml)

COBERTURA_FILEPATH = "psqa/tests/data/ubuntu-ui-toolkit-autolanding.coverage.xml"

class TestCoberturaReport(TestCase):

    def setUp(self):
        with open(COBERTURA_FILEPATH, 'r') as cobertura_file:
            self.cobertura_text = cobertura_file.read()

    def test_line_rate_is_correct(self):
        result = get_line_rate_from_cobertura_xml(self.cobertura_text)
        self.assertAlmostEqual(0.78105333, result)

    def test_branch_rate_is_correct(self):
        result = get_branch_rate_from_cobertura_xml(self.cobertura_text)
        self.assertAlmostEqual(0.54116025, result)
