
from mock import MagicMock, patch
from django.test import TestCase
from psqa.models import JenkinsCoverageReportManager

class TestCreateFromCoberturaXml(TestCase):
    def setUp(self):
        JenkinsCoverageReportManager.__init__ = MagicMock(
            spec=JenkinsCoverageReportManager,
            return_value=None)
        self.jenkins_coverage_report_manager = \
            JenkinsCoverageReportManager()


    def test_vanilla(self):
        self.jenkins_coverage_report_manager.create = MagicMock(
            return_value='SUCCESS')
        dummy_xml = "believe me this looks a lot like XML"
        dummy_jenkins_build = "a Django representation of a Jenkins build"
        get_line_rate = MagicMock(return_value=42.0)
        get_branch_rate = MagicMock(return_value=42.0)
        with patch('psqa.models.get_line_rate_from_cobertura_xml',
                   get_line_rate), \
                 patch('psqa.models.get_branch_rate_from_cobertura_xml',
                       get_branch_rate):
             result = self.jenkins_coverage_report_manager.create_from_cobertura_xml(
                 dummy_xml, dummy_jenkins_build)
        self.jenkins_coverage_report_manager.create.assert_called_with(
            xml_text=dummy_xml,
            jenkins_build=dummy_jenkins_build,
            line_rate=42.0,
            branch_rate=42.0)
        self.assertEqual('SUCCESS', result)
